/*
 * This is the script run by subscribers. It is used has a bridge between the
 * swarm and the GUI.
*/

/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80 */
/*global me*/

(function (me) {
  "use strict";

  me.onUpdate = function (timestamp) {
    var drone_dict = {};
    Object.entries(me.getDroneDict()).forEach(function ([id, drone]) {
      drone_dict[id] = {
        latitude: drone.latitude.toFixed(6),
        longitude: drone.longitude.toFixed(6),
        altitude: drone.altitudeAbs.toFixed(2),
        yaw: drone.yaw.toFixed(2),
        speed: drone.speed.toFixed(2),
        climbRate: drone.climbRate.toFixed(2),
        timestamp: drone.timestamp,
        log: drone.log
      };
    });
    me.writeWebsocketMessage(JSON.stringify({drone_dict: drone_dict}));
  }

  me.onWebSocketMessage = function (msg) {
    switch (msg) {
    case "quit":
      me.exit(0);
      break;
    case "start":
      me.sendMsg(JSON.stringify({status: "running"}));
      break;
    case "stop":
      me.sendMsg(JSON.stringify({status: "stopped"}));
      break;
    case "switch":
        me.sendMsg(JSON.stringify({status: "switch"}));
        break;
    default:
      me.writeWebsocketMessage("Unknown instruction " + msg);
    };
  }

  me.onGetMsg = function (msg) {
    me.writeWebsocketMessage(msg);
  };
}(me));
